
//*****************************************************************************
//* This source works with MSC 6.0 and above.
//*****************************************************************************

#include <stdio.h>

//     #define OS2

#include "mouse.h"

int main(void)
{
    int oldmx = -1, oldmy = -1;
    register int fs;

    mouse_open(25/2,80/2,0x7f,0,0);
    mouse_show();

    if (MOUSE_HANDLE == 0xff)
    {
        printf("Please install your mouse driver before running this test "
               "program.\n");
        return 0;
    }

    mouse_hide();
    printf("\x1b[2J"); /* Clear the screen with ANSI code. */

    printf("\x1b[5;1HClick here [] with left mouse button to quit.");
    printf("\x1b[7;1HMouse routine demonstration program.");
    printf("\x1b[8;1HCopyright (C) 1991, 1992 by Gary Wood.");
    mouse_show();

    for (;;)
    {
        if (MOUSE_EVENT_BUFFER.row != oldmx || MOUSE_EVENT_BUFFER.col != oldmy)
        {
            oldmx = MOUSE_EVENT_BUFFER.row;
            oldmy = MOUSE_EVENT_BUFFER.col;
            mouse_hide();
            printf("\x1b[1;1HMouse position: %3d, %3d", oldmx, oldmy);
            mouse_show();
        }

        fs = mouse_read(0);
        if (fs & MOUSE_BN1_DOWN) {
            if (MOUSE_EVENT_BUFFER.row == 2) mouse_hide();
            printf("\x1b[2;1HLeft button pressed at %3d, %3d ",
            MOUSE_EVENT_BUFFER.row, MOUSE_EVENT_BUFFER.col);
            if (MOUSE_EVENT_BUFFER.row == 2) mouse_show();
        }

        if (fs & MOUSE_BN2_DOWN) {
            if (MOUSE_EVENT_BUFFER.row == 3) mouse_hide();
            printf("\x1b[3;1HRight button pressed at %3d, %3d ",
            MOUSE_EVENT_BUFFER.row, MOUSE_EVENT_BUFFER.col);
            if (MOUSE_EVENT_BUFFER.row == 3) mouse_show();
        }

        if (fs & MOUSE_BN1_DOWN && MOUSE_EVENT_BUFFER.col > 11
          && MOUSE_EVENT_BUFFER.col < 14 && MOUSE_EVENT_BUFFER.row == 4)
        {
            mouse_close();
            printf("\x1b[2J"); /* Clear the screen with ANSI code. */
            return 0;
        }
    }
}
